#!/usr/bin/perl
##
##  setip.cgi -- Put address to be controlled from submitter's IP into
##      a database
##
use strict;
use IO::Socket::INET;
use CGI qw(:standard escapeHTML);  # CGI.pm simplifies HTML output
my $filename="/var/www/cgi-bin/datafiles/iptable";

$ENV{'PATH'} = '/bin:/usr/bin';
delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};
my $path = $ENV{'PATH'};       # $path now NOT tainted

print header;
print start_html(-title=>"Your IP Address input",-BGCOLOR=>'cyan'),
    h2('Your IP input'),
    hr;
print("Thank you!");
my $newip=param("ipadd");      # use a variable to limit vulnerability
print p,("You entered ",$newip," from ");
my $loc='';
$loc=$loc . " " . $ENV{REMOTE_ADDR} if exists $ENV{REMOTE_ADDR};
print($ENV{REMOTE_ADDR}," ") if exists $ENV{REMOTE_ADDR};
my $a1=0; my $a2=0; my $a3=0;
($a1,$a2,$a3)=split(/\./,$ENV{REMOTE_ADDR});
$newip="$a1"."."."$a2"."."."$a3".".".param("ipadd");
print p,("You will be controlling the robot at ",$newip);
# add to database
 dbmopen(my %FRED, "$filename", 0644); # open %FRED onto mydatabase
 my $key= $ENV{REMOTE_ADDR};
 $FRED{$key} = $newip;
 dbmclose(%FRED);
print p,("<a href=ipdump.cgi\>Click here to show the control database</a>");
print p,("<a href=http://$ENV{SERVER_ADDR}/mouse\>Click here to return to the
mouse control page</a>");
print end_html;
#
